import {useMemo as $3Sbms$useMemo} from "react";
import $3Sbms$swr from "swr";

function $parcel$export(e, n, v, s) {
  Object.defineProperty(e, n, {get: v, set: s, enumerable: true, configurable: true});
}
var $34ac2bb4f88650d4$exports = {};

$parcel$export($34ac2bb4f88650d4$exports, "Matrix", () => $34ac2bb4f88650d4$export$5b12bf1653c0dd85);


const $34ac2bb4f88650d4$var$typeNames = {
    count: (val)=>`Count of ${val}`
};
function $34ac2bb4f88650d4$export$5b12bf1653c0dd85({ columns: columns , rows: rows , values: values , appearance: appearance  }) {
    const { data: data  } = (0, $3Sbms$swr)(`/api/bioreactor/fetch?${new URLSearchParams({
        fields: [
            values.property,
            columns?.property,
            rows?.property, 
        ].filter((x)=>x).join(",")
    })}`, (...args)=>fetch.apply(null, args).then((res)=>res.json()));
    const columnHeadings = (0, $3Sbms$useMemo)(()=>{
        if (typeof data === "undefined") return [];
        if (typeof columns === "undefined") return null;
        const headings = new Set();
        for(let i = 0; i < data.values.length; i++)headings.add(data.values[i][columns.property]);
        return Array.from(headings);
    }, [
        columns,
        values,
        data
    ]);
    const rowHeadings = (0, $3Sbms$useMemo)(()=>{
        if (typeof data === "undefined") return [];
        if (typeof rows === "undefined") return null;
        const headings = new Set();
        for(let i = 0; i < data.values.length; i++)headings.add(data.values[i][rows.property]);
        return Array.from(headings).sort();
    }, [
        rows,
        values,
        data
    ]);
    const matrixValues = (0, $3Sbms$useMemo)(()=>{
        if (typeof data === "undefined") return null;
        if (columnHeadings === null && rowHeadings === null) return data.values.length;
        else if (rowHeadings === null && columnHeadings !== null) {
            const arr = new Array(columnHeadings.length);
            const colProp = columns.property;
            for(let i = 0; i < columnHeadings.length; i++)arr[i] = data.values.filter((x)=>x[colProp] === columnHeadings[i]).length;
            return [
                arr
            ];
        } else if (rowHeadings !== null && columnHeadings !== null) {
            const arr1 = new Array(rowHeadings.length);
            const colProp1 = columns.property;
            const rowProp = rows.property;
            for(let i1 = 0; i1 < rowHeadings.length; i1++){
                const arr2 = new Array(columnHeadings.length);
                for(let j = 0; j < columnHeadings.length; j++)arr2[j] = data.values.filter((x)=>x[colProp1] === columnHeadings[j] && x[rowProp] === rowHeadings[i1]).length;
                arr1[i1] = arr2;
            }
            return arr1;
        } else if (rowHeadings !== null && columnHeadings === null) {
            const arr3 = new Array(rowHeadings.length);
            const rowProp1 = rows.property.split(".")[1];
            for(let i2 = 0; i2 < rowHeadings.length; i2++)arr3[i2] = [
                data.values.filter((x)=>x[rowProp1] === rowHeadings[i2]).length
            ];
            return arr3;
        }
    }, [
        data,
        columnHeadings,
        rowHeadings,
        values
    ]);
    return /*#__PURE__*/ React.createElement(React.Fragment, null, matrixValues === null || !data ? appearance?.placeholder ?? null : /*#__PURE__*/ React.createElement("table", {
        className: appearance?.classNames?.table
    }, /*#__PURE__*/ React.createElement("thead", {
        className: appearance?.classNames?.header
    }, /*#__PURE__*/ React.createElement("tr", null, rows ? /*#__PURE__*/ React.createElement("th", {
        className: appearance?.classNames?.columnHeader?.(0, rows)
    }, rows.name) : null, columns && columnHeadings ? /*#__PURE__*/ React.createElement(React.Fragment, null, columnHeadings.map((heading, idx)=>/*#__PURE__*/ React.createElement("th", {
            key: idx,
            className: appearance?.classNames?.columnHeader?.(rows ? idx + 1 : idx, columns)
        }, heading))) : /*#__PURE__*/ React.createElement("th", {
        className: appearance?.classNames?.columnHeader?.(rows ? 1 : 0, values)
    }, $34ac2bb4f88650d4$var$typeNames[values.type](values.name)))), /*#__PURE__*/ React.createElement("tbody", {
        className: appearance?.classNames?.body
    }, rows && rowHeadings ? rowHeadings.map((row, idx)=>/*#__PURE__*/ React.createElement("tr", {
            key: idx,
            className: appearance?.classNames?.row?.(idx)
        }, /*#__PURE__*/ React.createElement("td", {
            className: appearance?.classNames?.rowHeader?.(idx, rows)
        }, row), matrixValues[idx].map((value, idx2)=>/*#__PURE__*/ React.createElement("td", {
                key: idx2,
                className: appearance?.classNames?.cell?.(values)
            }, value)))) : /*#__PURE__*/ React.createElement("tr", {
        className: appearance?.classNames?.row?.(0)
    }, columnHeadings === null ? matrixValues : matrixValues[0].map((value, idx)=>/*#__PURE__*/ React.createElement("td", {
            key: idx,
            className: appearance?.classNames?.cell?.(values)
        }, value))))));
}


function $24075a5d702d64b3$var$parseFields(query) {
    if (typeof query === "undefined") return [];
    else if (typeof query === "string") return query.split(",");
    else return query[0].split(",");
}
function $24075a5d702d64b3$export$4c00741285d8b471({ name: name , columns: columns  }) {
    return {
        ...Object.fromEntries(columns.map((column)=>[
                column,
                {
                    property: `${name}.${String(column)}`,
                    name: String(column),
                    count: ()=>({
                            property: `${name}.${String(column)}`,
                            name: String(column),
                            type: "count"
                        })
                }
            ])),
        handler: (source)=>async (req, res)=>{
                const { bi: bi  } = req.query;
                if (typeof bi === "undefined" || bi.length < 2 || bi[0] !== "bioreactor") return res.status(404).end();
                const data = await source(req);
                if (bi[1] === "fetch") {
                    const vals = [];
                    const fields = $24075a5d702d64b3$var$parseFields(req.query.fields);
                    const properties = fields.map((x)=>x.split(".")[1]);
                    const tableName = fields[0].split(".")[0];
                    let i = 0, l = data.length;
                    while(i < l){
                        let val = {};
                        for (const prop of properties)val[`${tableName}.${prop}`] = data[i][prop];
                        vals.push(val);
                        i++;
                    }
                    return res.status(200).json({
                        values: vals
                    });
                }
                res.status(404).end();
            }
    };
}


export {$24075a5d702d64b3$export$4c00741285d8b471 as defineTable, $34ac2bb4f88650d4$export$5b12bf1653c0dd85 as Matrix};
